#include "mainwindow.h"
#include "odlanrfid_demo_global.h"

#include <QApplication>
#include <QMessageBox>

#include <QCommandLineOption>
#include <QCommandLineParser>

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    a.setOrganizationName("Open-dev.ru");
    a.setApplicationName("ODLANRFID_Demo");
    a.setApplicationVersion("0.0.1");
    a.addLibraryPath(a.applicationDirPath());

    QCommandLineParser parser;

    QCommandLineOption portOption(QStringList()<<"p"<<"port", "Change UDP port.", "port", "5555");
    parser.addOption(portOption);

    parser.addVersionOption();
    parser.addHelpOption();

    parser.process(a);

    if(parser.isSet(portOption))
    {
        QSettings().setValue(SETTINGS_PORT, parser.value(portOption).toUInt());
    }

    MainWindow w;
    if(!w.readSettings())
    {
        QMessageBox::critical(nullptr, QLatin1Literal("ODLANRFID Demo"), QLatin1Literal("Settings are invalid."));
        return 1;
    }
    w.show();

    return a.exec();
}
