#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QSettings>
#include <QUdpSocket>
#include <QSqlDatabase>
#include <QTimer>
#include <QMovie>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
        Q_OBJECT

    public:
        enum Mode {
            Scanning,
            NewEntry,
        };

        explicit MainWindow(QWidget *parent = nullptr);
        ~MainWindow();

        bool readSettings();

    private slots:
        void socket_readyRead();
        void clean_timeout();

        void on_actionPreferences_triggered();
        void on_actionAdd_Entry_triggered();
        void on_actionAbout_triggered();
        void on_actionClean_Database_triggered();
    private:
        Ui::MainWindow *ui;
        Mode run_mode;
        QSettings set;
        QUdpSocket socket;
        QTimer cleanTimer;
        QMovie* loaderGif;

        void initDatabase();
        void displayInvalid(const QString& uuid);

        bool initSocket();
        bool displayUID(const QByteArray& id);
        bool saveUID(const QByteArray& id);
        void processDatagram(const QNetworkDatagram& datagram);
        void finishEditing();
};

#endif // MAINWINDOW_H
