#ifndef QIMAGELABEL_H
#define QIMAGELABEL_H

#include <QLabel>
#include <QDragEnterEvent>
#include <QDropEvent>

class QImageLabel : public QLabel
{
        Q_PROPERTY(bool readOnly READ readOnly WRITE setReadOnly)
        Q_OBJECT
    public:
        QImageLabel(QWidget* parent = nullptr);
        ~QImageLabel();

        bool hasImage() const;
        void setImage(const QByteArray& data, const char* fmt = nullptr);
        QByteArray getImage(const char* fmt = nullptr) const;

        bool readOnly() const;
        void setReadOnly(bool on);
    protected:
        void dragEnterEvent(QDragEnterEvent *event) Q_DECL_OVERRIDE;
        void dropEvent(QDropEvent* event) Q_DECL_OVERRIDE;
    private:
        QImage droppedImage;
};

#endif // QIMAGELABEL_H
